/*****************************************************************************
 * Copyright (C) 2014
 *   
 * Michiel Broek <mbroek at mbse dot eu>
 *
 * This file is part of the mbsePi-apps
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * mbsePi-apps is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with EC-65K; see the file COPYING.  If not, write to the Free
 * Software Foundation, 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 *****************************************************************************/

#include "rc433.h"

#ifdef HAVE_WIRINGPI_H

int main(int argc, char *argv[]) {
  
    // This pin is not the first pin on the RPi GPIO header!
    // Consult https://projects.drogon.net/raspberry-pi/wiringpi/pins/
    // for more information.
    int PIN = 2;
     
    if (wiringPiSetup() == -1)
	return 0;

    enableReceiveIRQ(PIN);  // Receiver on inerrupt 0 => that is pin #2
    
    while(1) {
 
	if (available()) {
	    unsigned long value = getReceivedValue();
    
	    if (value == 0) {
		printf("Unknown encoding\n");
	    } else {    
	printf("Protocol %d received 0x%lx\n", getReceivedProtocol(), value);
	    }
	    resetAvailable();
    
	} else {
	    /*
	     * Don't hog the CPU
	     */
	    delay(10);
	}
    }

    exit(0);
}

#else

int main(int argc, char *argv[]) {
    fprintf(stderr, "This program does nothing without the wiringPi library\n");
    return 0;
}

#endif

